#include <IRLib.h>
#include <LiquidCrystal.h>

int RECV_PIN = 6;
// initialize the library with the numbers of the interface pins
LiquidCrystal lcd(12, 11, 5, 4, 3, 2);


IRrecv My_Receiver(RECV_PIN);
IRdecode My_Decoder;
IRdecodeHash My_Hash_Decoder;

//Xinda2
#define RIGHT_ARROW   2246090081
#define LEFT_ARROW    3419589885
#define OK_BUTTON     629155073
#define UP_ARROW      1868133565
#define DOWN_ARROW    1474512609
#define BUTTON_0      1113853081
#define BUTTON_1      3001999165
#define BUTTON_2      211564353
#define BUTTON_3      46690913
#define BUTTON_4      373604801
#define BUTTON_5      2797147069
#define BUTTON_6      3495072293
#define BUTTON_7      32049505
#define BUTTON_8      2455591773
#define BUTTON_9      3409801085
#define STAR          2985278109
#define HASHKEY       1811778305
#define JUNK          84696351
#define JUNK1         84696349



int A = 2;
int B = 3;
int C = 4;
int D = 5;

long duty = 50;
int waitMicroSeconds = 100;
int pulseCount = 25;


//int speed1 = (waitMicroSeconds / pulseCount) / 100 ;

//int trigger = A0; // used only for testing purposes (trigger on oscilloscope)
long unsigned mvalue  ;
int location = 0 ;
const int  track0 = 0 ;
const int  track1 = 1 ;
const int  track2 = 2 ;
const int  track3 = 3 ;
const int  track4 = 4 ;
const int  track5 = 25 ;
const int right = false;
const int left = true;

void setup() {
  pinMode(A, OUTPUT);
  pinMode(B, OUTPUT);
  pinMode(C, OUTPUT);
  pinMode(D, OUTPUT);

  // pinMode(trigger, OUTPUT);
  My_Receiver.enableIRIn(); // Start the receiver
  Serial.begin(9600);

  lcd.begin(16, 2);
  line2() ;
  lcd.setCursor(0, 0);
  lcd.print("Awaiting Command");

}

void one() {
  digitalWrite(A, HIGH);
  digitalWrite(B, LOW);
  digitalWrite(C, HIGH);
  digitalWrite(D, LOW);
}

void two() {
  digitalWrite(A, HIGH);
  digitalWrite(B, LOW);
  digitalWrite(C, LOW);
  digitalWrite(D, HIGH);
}

void three() {
  digitalWrite(A, LOW);
  digitalWrite(B, HIGH);
  digitalWrite(C, LOW);
  digitalWrite(D, HIGH);
}

void four() {
  digitalWrite(A, LOW);
  digitalWrite(B, HIGH);
  digitalWrite(C, HIGH);
  digitalWrite(D, LOW);
}


void oneB() {
  digitalWrite(A, HIGH);
  digitalWrite(B, LOW);
  digitalWrite(C, LOW);
  digitalWrite(D, LOW);
}

void twoB() {
  digitalWrite(A, LOW);
  digitalWrite(B, LOW);
  digitalWrite(C, LOW);
  digitalWrite(D, HIGH);
}

void threeB() {
  digitalWrite(A, LOW);
  digitalWrite(B, HIGH);
  digitalWrite(C, LOW);
  digitalWrite(D, LOW);
}

void fourB() {
  digitalWrite(A, LOW);
  digitalWrite(B, LOW);
  digitalWrite(C, HIGH);
  digitalWrite(D, LOW);
}


// main routine to microstep
void doStep(int st) {

  long dt1 = waitMicroSeconds * duty / 100;
  long dt2 = waitMicroSeconds * (100 - duty) / 100;

  for (int j = 0; j < pulseCount; j++) {
    switch (st) {
      case 1: one(); break;
      case 2: two(); break;
      case 3: three(); break;
      case 4: four(); break;
      case 11: oneB(); break;
      case 12: twoB(); break;
      case 13: threeB(); break;
      case 14: fourB(); break;

      case 21: one(); break;
      case 22: two(); break;
      case 23: three(); break;
      case 24: four(); break;
      case 31: oneB(); break;
      case 32: twoB(); break;
      case 33: threeB(); break;
      case 34: fourB(); break;

    }

    delayMicroseconds(dt1);

    switch (st) {
      case 1: one(); break;
      case 2: two(); break;
      case 3: three(); break;
      case 4: four(); break;
      case 11: oneB(); break;
      case 12: twoB(); break;
      case 13: threeB(); break;
      case 14: fourB(); break;

      case 21: oneB(); break;
      case 22: twoB(); break;
      case 23: threeB(); break;
      case 24: fourB(); break;
      case 31: two(); break;
      case 32: three(); break;
      case 33: four(); break;
      case 34: one(); break;
    }
    delayMicroseconds(dt2);

  }
}

// disable motor
void motorOff() {
  /* Important note:
       Turning off the motor will make it go into a 'rest' state.
       When using microsteps (or even full steps), this may not be the last active step.
       So using this routine may change the position of the motor a bit.
  */

  digitalWrite(A, LOW);
  digitalWrite(B, LOW);
  digitalWrite(C, LOW);
  digitalWrite(D, LOW);
}

// full stepping 4 steps :
void do4Steps(int cnt, boolean forwards) {
  for (int i = 0; i < cnt; i++) {
    duty = 50;
    if (forwards)
    {
      for (int j = 1; j <= 4; j++) {
        doStep(j);
      }
    }
    else
    {
      for (int j = 4; j >= 1; j--) {
        doStep(j);
      }
    }

  }
}

// half stepping 8 steps :
void do8Steps(int cnt, boolean forwards) {
  const int list[] = {1, 11, 2, 12, 3, 13, 4, 14};
  for (int i = 0; i < cnt; i++) {
    duty = 50;
    if (forwards)
    {
      for (int j = 0; j <= 7; j++) {
        doStep(list[j]);
      }
    }
    else
    {
      for (int j = 7; j >= 0; j--) {
        doStep(list[j]);
      }
    }
  }
}


// microstepping 16 steps :
void do16Steps(int cnt, boolean forwards) {

  const int list[] = {1, 21, 11, 31, 2, 22, 12, 32, 3, 23, 13, 33, 4, 24, 14, 34};
  for (int i = 0; i < cnt; i++) {
    duty = 50;
    if (forwards)
    {
      for (int j = 0; j <= 15; j++) {
        doStep(list[j]);
      }
    }
    else
    {
      for (int j = 15; j >= 0; j--) {
        doStep(list[j]);
      }
    }
  }
}

// microstepping >16 steps :
void doMoreSteps(int cnt, boolean forwards) {
  const int list1[] = {1, 11, 2, 12, 3, 13, 4, 14};
  const int list2[] = {21, 31, 22, 32, 23, 33, 24, 34};

  for (int i = 0; i < cnt; i++) {

    duty = 50;
    if (forwards)
    {
      for (int j = 0; j <= 7; j++) {
        doStep(list1[j]);
        doSteps(list2[j], forwards);
      }
    }
    else
    {
      for (int j = 7; j >= 0; j--) {
        doSteps(list2[j], forwards);
        doStep(list1[j]);
      }
    }

  }
}

// this routine handles >16 microsteps
// uncomment sections to choose # steps
void doSteps(int st, boolean forwards) {

  // *********************** 24 steps
  /*
    if (forwards){
      duty = 66;    doStep(st);
      duty = 33;    doStep(st);
    }
    else{
      duty = 33;    doStep(st);
      duty = 66;    doStep(st);
    }
  */


  // *********************** 32 steps
  /*
    if (forwards){
      duty = 75;    doStep(st);
      duty = 50;    doStep(st);
      duty = 25;    doStep(st);
    }
    else{
      duty = 25;    doStep(st);
      duty = 50;    doStep(st);
      duty = 75;    doStep(st);
    }
  */

  // *********************** 48 steps

  /*  if (forwards){
      for (int i = 5; i >= 1; i--){duty = 17 * i; doStep(st);}
    }
    else{
      for (int i = 1; i <= 5; i++){duty = 17 * i; doStep(st);}
    }
  */


  // *********************** 64 steps
  /*
    if (forwards){
      for (int i = 7; i >= 1; i--){duty = 12 * i; doStep(st);}
    }
    else{
      for (int i = 1; i <= 7; i++){duty = 12 * i; doStep(st);}
    }
  */

  // *********************** 96 steps
  if (forwards) {
    for (int i = 9; i >= 1; i--) {
      duty = 10 * i;
      doStep(st);
    }
  }
  else {
    for (int i = 1; i <= 9; i++) {
      duty = 10 * i;
      doStep(st);
    }
  }

}

void line2() {
  lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("Speed:");
  lcd.print(speed1);
  lcd.print(" 96 Steps");
  lcd.setCursor(0, 0);
}


// the loop routine runs over and over again forever:
void loop() {

  // uncomment this to disable motor
  //  motorOff();return;


  /* control the speed of the motor with a waitMicroseconds/pulseCount pair
     e.g. waitMicroSeconds / pulseCount
          500 / 5 --> one step takes 2500 microseconds
          50 / 50 --> one step also takes 2500 microseconds
          but in second pair the fequency of the wave is 20kHz, not audible..
          in 500 / 5 you may hear a high tone in the motor in microsteps
          some motors may not respond well on higher frequencies
     note: these parameters also control speed in normal stepping (full or half) although there's no pulses in those cases,
              setting pulseCount = 1 might be more readable
  */
  waitMicroSeconds = 500;
  pulseCount = 50 ;
  mvalue = 0 ;
  /*  uncomment one of the next routines to choose stepping mode
    do4Steps : full stepping
    do8Steps : half stepping
    do16Steps : microstepping with 16 steps
    doMoreSteps : microstepping with more than 16 steps
       --> check routine 'doSteps' for extra uncomments

    two parameters:
      1. number of steps
      2. forwards = true --> move forwards   /  forwards = left --> move backwards

    note: there's no speed correction for different modes, so do4Steps makes the motor go twice as fast as do8Steps and so on...
          use waitMicroseconds and pulseCount to adapt speed when changing modes
  */
  if (My_Receiver.GetResults(&My_Decoder)) {//Puts results in My_Decoder
    My_Hash_Decoder.copyBuf(&My_Decoder);//copy the results to the hash decoder
    My_Decoder.decode();
    My_Hash_Decoder.decode();
    mvalue = (My_Hash_Decoder.hash) ;
    //Serial.println(My_Hash_Decoder.hash, DEC); // Do something interesting with this value
    My_Receiver.resume();
  }
  if (mvalue == OK_BUTTON)  {
    line2();
    lcd.print("Zero Set");
    doMoreSteps(0, right);
    motorOff();
    location = 0 ;
  }
  if (mvalue == RIGHT_ARROW ) {
    line2();
    lcd.print("One Step +");
    doMoreSteps(1, right);
    motorOff();
    mvalue = 0;
    location = location + 1 ;
  }
  if (mvalue == LEFT_ARROW  ) {
    line2();
    lcd.print("One Step -");
    doMoreSteps(1, left);
    motorOff();
    mvalue = 0 ;
    location = location - 1 ;
  }
  if (mvalue == BUTTON_0) {
    line2();
    lcd.print("Going to Track 0");
    switch (location) {
      case track0 :
        // do noth
        break ;
      case track1 :
        doMoreSteps(track1 - track0, left) ;
        break ;
      case track2 :
        doMoreSteps(track2 - track0, left) ;
        break ;
      case track3 :
        doMoreSteps(track3 - track0, left) ;
        break ;
      case track4 :
        doMoreSteps(track4 - track0, left) ;
        break ;
      case track5 :
        doMoreSteps(track5 - track0, left) ;
        break ;
    }
    location = track0 ;
    line2();
    lcd.print("Location Track 0");
  }
  if (mvalue == BUTTON_1) {
    line2();
    lcd.print("Going to Track 1");
    switch (location) {
      case track0 :
        doMoreSteps(track1, right) ;
        break ;
      case track1 :
        // do noth
        break ;
      case track2 :
        doMoreSteps(track2 - track1, left) ;
        break ;
      case track3 :
        doMoreSteps(track3 - track1, left) ;
        break ;
      case track4 :
        doMoreSteps(track4 - track1, left) ;
        break ;
      case track5 :
        doMoreSteps(track5 - track1, left) ;
        break ;
    }
    location = track1 ;
    line2();
    lcd.print("Location Track 1");
  }
  if (mvalue == BUTTON_2) {
    line2();
    lcd.print("Going to Track 2");
    switch (location) {
      case track0 :
        doMoreSteps(track2, right) ;
        break ;
      case track1 :
        doMoreSteps(track2 - track1, right) ;
        break ;
      case track2 :
        // do noth
        break ;
      case track3 :
        doMoreSteps(track3 - track2, left) ;
        break ;
      case track4 :
        doMoreSteps(track4 - track2, left) ;
        break ;
      case track5 :
        doMoreSteps(track5 - track2, left) ;
        break ;
    }
    location = track2 ;
    line2();
    lcd.print("Location Track 2");
  }
  if (mvalue == BUTTON_3) {
    line2();
    lcd.print("Going to Track 3");
    switch (location) {
      case track0 :
        doMoreSteps(track3, right) ;
        break ;
      case track1 :
        doMoreSteps(track3 - track1, right) ;
        break ;
      case track2 :
        doMoreSteps(track3 - track2, right) ;
        break ;
      case track3 :
        // do noth
        break ;
      case track4 :
        doMoreSteps(track4 - track3, left) ;
        break ;
      case track5 :
        doMoreSteps(track5 - track3, left) ;
        break ;
    }
    location = track3 ;
    line2();
    lcd.print("Location Track 3");
  }
  if (mvalue == BUTTON_4) {
    line2();
    lcd.print("Going to Track 4");
    switch (location) {
      case track0 :
        doMoreSteps(track4, right) ;
        break ;
      case track1 :
        doMoreSteps(track4 - track1, right) ;
        break ;
      case track2 :
        doMoreSteps(track4 - track2, right) ;
        break ;
      case track3 :
        doMoreSteps(track4 - track3, right) ;
        break ;
      case track4 :
        // do noth
        break ;
      case track5 :
        doMoreSteps(track5 - track3, left) ;
        break ;
    }
    location = track4 ;
    line2();
    lcd.print("Location Track 4");
  }
  if (mvalue == BUTTON_5) {
    line2();
    lcd.print("Going to Track 5");
    switch (location) {
      case track0 :
        doMoreSteps(track5, right) ;
        break ;
      case track1 :
        doMoreSteps(track5 - track1, right) ;
        break ;
      case track2 :
        doMoreSteps(track5 - track2, right) ;
        break ;
      case track3 :
        doMoreSteps(track5 - track3, right) ;
        break ;
      case track4 :
        doMoreSteps(track5 - track4, right) ;
        break ;
      case track5 :
        location = track5 ;
        // do noth
        break ;
    }
    location = track5 ;
    line2();
    lcd.print("Location Track 5");
  }
  motorOff(); // give it a rest (see note in motorOff about losing steps)




  //  // uncomment this to disable motor
  //  //  motorOff();return;
  //
  //
  //  /* control the speed of the motor with a waitMicroseconds/pulseCount pair
  //     e.g. waitMicroSeconds / pulseCount
  //          500 / 5 --> one step takes 2500 microseconds
  //          50 / 50 --> one step also takes 2500 microseconds
  //          but in second pair the fequency of the wave is 20kHz, not audible..
  //          in 500 / 5 you may hear a high tone in the motor in microsteps
  //          some motors may not respond well on higher frequencies
  //     note: these parameters also control speed in normal stepping (full or half) although there's no pulses in those cases,
  //              setting pulseCount = 1 might be more readable
  //  */
  //  waitMicroSeconds = 1000;
  //  pulseCount = 25;
  //
  //  /*  uncomment one of the next routines to choose stepping mode
  //    do4Steps : full stepping
  //    do8Steps : half stepping
  //    do16Steps : microstepping with 16 steps
  //    doMoreSteps : microstepping with more than 16 steps
  //       --> check routine 'doSteps' for extra uncomments
  //
  //    two parameters:
  //      1. number of steps
  //      2. forwards = true --> move forwards   /  forwards = false --> move backwards
  //
  //    note: there's no speed correction for different modes, so do4Steps makes the motor go twice as fast as do8Steps and so on...
  //          use waitMicroseconds and pulseCount to adapt speed when changing modes
  //
  //  */
  //
  //  //  do4Steps(24, true);
  //  //  do8Steps(24, true);
  //  //  do16Steps(24, true);
  //  doMoreSteps(24, true);
  //
  //  motorOff(); // give it a rest (see note in motorOff about losing steps)
  //  delay(1000);
  //
  //  //  do4Steps(24, false);
  //  //  do8Steps(24, false);
  //  //  do16Steps(24, false);
  //  doMoreSteps(24, false);
  //
  //  motorOff(); // give it a rest (see note in motorOff about losing steps)
  //  delay(1000);

}
